\documentclass{article}
\title{The C++ Digital Signal Processing classes}
\author{E. Robert Tisdale}
\begin{document}
\bibliographystyle{plain}
\maketitle

\begin{abstract}
\end{abstract}

\section{Window Functions}
\begin{equation}
w_{n-1-k} = w_{k}
\end{equation}

\subsection{Blackman}
{\tt <Type>Vector w = <Type>Blackman(n);}

\begin{eqnarray}
w_{k}&=&0.42 - 0.5\cdot\cos\left(\frac{2\pi k}{n-1}\right)
      + 0.08\cdot\cos\left(\frac{4\pi k}{n-1}\right)		\nonumber\\
     &=&0.5\left(1 - \cos\left(\frac{2\pi k}{n-1}\right)\right)
      - 0.08\left(1 - \cos\left(\frac{4\pi k}{n-1}\right)\right)\nonumber\\
     &=&1 - \cos^{2}\left(\frac{\pi k}{n-1}\right)
      - 0.16\left(1 - \cos^{2}\left(\frac{2\pi k}{n-1}\right)\right)\nonumber\\
     &=&\sin^{2}\left(\frac{\pi k}{n-1}\right)
      - 0.16\sin^{2}\left(\frac{2\pi k}{n-1}\right)		\nonumber\\
     &=&\sin^{2}\left(\frac{\pi k}{n-1}\right)
      - 0.64\sin^{2}\left(\frac{\pi k}{n-1}\right)
	\left(1 - \sin^{2}\left(\frac{\pi k}{n-1}\right)\right)	\nonumber\\
     &=&0.36\sin^{2}\left(\frac{\pi k}{n-1}\right)
      + 0.64\sin^{4}\left(\frac{\pi k}{n-1}\right)		\nonumber\\
     &=&\left(\frac{4}{5}\right)^{2}\sin^{2}\left(\frac{\pi k}{n-1}\right)
	\left(\left(\frac{3}{4}\right)^{2}
      + \sin^{2}\left(\frac{\pi k}{n-1}\right)\right)
\end{eqnarray}

\subsection{Dolph-Chebyshev}
{\tt <Type>Vector w = <Type>Chebyshev(n, ripple);}

\begin{equation}
\delta_{p} = 10^{-\mbox{ripple}/20}
\end{equation}
\begin{equation}
\tau_{p} = \frac{1 + \delta_{p}}{\delta_{p}}
\end{equation}
\begin{equation}
\sigma_{p} = \cosh\left(\frac{\cosh^{-1}(\tau_{p})}{n-1}\right)
\end{equation}
\begin{equation}
% \delta_{f} = \frac{1}{\pi}\cdot \cos^{-1}\left[
%	\frac{1}{\cosh\left(\frac{\cosh^{-1}(\tau_{p})}{n-1}\right)}\right]
\delta_{f} = \frac{1}{\pi}\cdot \cos^{-1}\left(1/\sigma_{p}\right)
\end{equation}
\begin{eqnarray}
x_{0}&=&\frac{3 - \cos(2\pi\delta_{f})}{1 + \cos(2\pi\delta_{f})}  \nonumber\\
     &=&\frac{3 - (2\cos^{2}(\pi\delta_{f}) - 1)}
	     {1 + (2\cos^{2}(\pi\delta_{f}) - 1)}		   \nonumber\\
     &=&\frac{2 - \cos^{2}(\pi\delta_{f})}{\cos^{2}(\pi\delta_{f})}\nonumber\\
     &=&2\sigma_{p}^{2} - 1\
%    &=&\frac{2}{\cos^{2}(\pi\delta_{f})} - 1			   \nonumber\\
%    &=&2\cosh^{2}\left(\frac{\cosh^{-1}(\tau_{p})}{n-1}\right) - 1\nonumber\\
%    &=&\cosh\left(\frac{2\cosh^{-1}(\tau_{p})}{n-1}\right)
\end{eqnarray}
\begin{eqnarray}
x_{k}&=&\frac{x_{0} + 1}{2}\cos(2\pi k/n) + \frac{x_{0} - 1}{2}	\nonumber\\
     &=&\frac{x_{0} + 1}{2}\left(2\cos^{2}(\pi k/n) - 1\right)
      + \frac{x_{0} - 1}{2}					\nonumber\\
     &=&(x_{0} + 1)\cos^{2}(\pi k/n) - 1			\nonumber\\
     &=&2\sigma_{p}^{2}\cdot\cos^{2}(\pi k/n) - 1 \geq -1
%    &=&2\cosh^{2}\left(\frac{\cosh^{-1}(\tau_{p})}{n-1}\right)
%	 \cos^{2}(\pi k/n) - 1
\end{eqnarray}
\begin{equation}
x_{n-k} = x_{k}
\end{equation}
\begin{equation}
x_{n/2} = -1
\end{equation}
\begin{equation}
r_{k} = \left\{\begin{array}{lll}
\cos\left(\frac{n-1}{2}\cos^{-1}(x_{k})\right)& \mbox{if}& |x_{k}| \leq 1 \\
\\
\cosh\left(\frac{n-1}{2}\cosh^{-1}(x_{k})\right)& \mbox{if}& 1 < |x_{k}|
\end{array}\right.
\end{equation}
\begin{equation}
r_{n/2} = 0
\end{equation}
\begin{equation}
t_{k} = r_{k}
\end{equation}
if $n$ is odd.
\begin{equation}
t_{k} = \left\{\begin{array}{ll}
+r_{k}e^{i\pi k/n}& \forall k\; |\; 0 \leq k < n/2 \\
\\
-r_{k}e^{i\pi k/n}& \forall k\; |\; n/2 \leq k < n \\
\end{array}\right.
\end{equation}
if $n$ even.
\begin{equation}
t_{n-k} = t_{k}^{*}
\end{equation}
\begin{equation}
t_{n/2} = 0
\end{equation}
\begin{equation}
w_{j} = \sum_{k=0}^{n-1}t_{k}e^{i2\pi jk/n}
\end{equation}
\begin{equation}
w_{j} \leftarrow \left\{\begin{array}{ll}
w_{j + (n+1)/2 \bmod n}& \mbox{if}\ n\ \mbox{is odd}	\\
\\
w_{j + n/2 \bmod n}&     \mbox{if}\ n\ \mbox{is even}	\\
\end{array}\right.
\end{equation}
$\forall j\; |\; 0 \leq j < n$.

\subsection{Hamming}
{\tt <Type>Vector w = <Type>Hamming(n);}

\begin{eqnarray}
w_{k}&=&0.54 - 0.46\cos\left(\frac{2\pi k}{n-1}\right)		\nonumber\\
     &=&0.54 - 0.46\left(2\cos^{2}\left(\frac{\pi k}{n-1}\right) - 1\right)\nonumber\\
     &=&1 - 0.92\cos^{2}\left(\frac{\pi k}{n-1}\right)		\nonumber\\
     &=&0.08 + 0.92\sin^{2}\left(\frac{\pi k}{n-1}\right)
\end{eqnarray}

\subsection{Hanning}
{\tt <Type>Vector w = <Type>Hanning(n);}

\begin{eqnarray}
w_{k}&=&\frac{1}{2}\left(1 - \cos\left(
	\frac{2\pi(k+1)}{n+1}\right)\right)			\nonumber\\
     &=&\frac{1}{2}\left(1 - \left(2\cos^{2}\left(
	\frac{\pi(k+1)}{n+1}\right) - 1\right)\right)		\nonumber\\
     &=&\sin^{2}\left(\frac{\pi(k+1)}{n+1}\right)
\end{eqnarray}

\subsection{Kaiser}
{\tt <Type>Vector w = <Type>Kaiser(n, beta);}

\begin{eqnarray}
w_{k}&=&\frac{I_{0}\left(\beta\sqrt{1 - \left(
	\frac{2k -(n-1)}{n-1}\right)^{2}}\right)}{I_{0}(\beta)}	\nonumber\\
     &=&\frac{I_{0}\left(\frac{\beta}{n\!-\!1}\sqrt{(n-1)^{2}
      - \left(2k -(n\!-\!1)\right)^{2}}\right)}{I_{0}(\beta)}	\nonumber\\
     &=&\frac{I_{0}\left(\frac{2\beta}{n-1}\sqrt{k(n\!-\!1\!-\!k)}\right)}{I_{0}(\beta)}
\end{eqnarray}

\section{Discrete Fourier Transforms}
\subsection{1 Dimensional DFTs}
\subsubsection{Return by Reference (In Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>1DCCDDFT(n, i)}&{\tt <Type>1DCCIDFT(n, i)}&Complex to Complex\\
{\tt <Type>1DRCDDFT(n, i)}&{\tt <Type>1DRCIDFT(n, i)}&
\multicolumn{1}{r}{Real to Complex}\\
{\tt <Type>1DCRDDFT(n, i)}&{\tt <Type>1DCRIDFT(n, i)}&Complex to Real
\end{tabular}
\end{center}

\subsubsection{Return by Value (Out of Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>1DCDDFTC(n, i)}&{\tt <Type>1DCIDFTC(n, i)}&Complex from Complex\\
{\tt <Type>1DCDDFTR(n, i)}&{\tt <Type>1DCIDFTR(n, i)}&Complex from Real	\\
{\tt <Type>1DRDDFTC(n, i)}&{\tt <Type>1DRIDFTC(n, i)}&
\multicolumn{1}{r}{Real from Complex}
\end{tabular}
\end{center}

\subsubsection{Resize}
{\tt resize(n, i)}

\subsection{2 Dimensional DFTs}
\subsubsection{Return by Reference (In Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>2DCCDDFT(m, n, i)}&{\tt <Type>2DCCIDFT(m, n, i)}&
Complex to Complex							\\
{\tt <Type>2DRCDDFT(m, n, i)}&{\tt <Type>2DRCIDFT(m, n, i)}&
\multicolumn{1}{r}{Real to Complex}					\\
{\tt <Type>2DCRDDFT(m, n, i)}&{\tt <Type>2DCRIDFT(m, n, i)}&
Complex to Real
\end{tabular}
\end{center}

\subsubsection{Return by Value (Out of Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>2DCDDFTC(m, n, i)}&{\tt <Type>2DCIDFTC(m, n, i)}&
Complex from Complex							\\
{\tt <Type>2DCDDFTR(m, n, i)}&{\tt <Type>2DCIDFTR(m, n, i)}&
Complex from Real							\\
{\tt <Type>2DRDDFTC(m, n, i)}&{\tt <Type>2DRIDFTC(m, n, i)}&
\multicolumn{1}{r}{Real from Complex}
\end{tabular}
\end{center}

\subsubsection{Resize}
{\tt resize(m, n, i)}

\subsection{3 Dimensional DFTs}
\subsubsection{Return by Reference (In Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>3DCCDDFT(l, m, n, i)}&{\tt <Type>3DCCIDFT(l, m, n, i)}&
Complex to Complex							\\
{\tt <Type>3DRCDDFT(l, m, n, i)}&{\tt <Type>3DRCIDFT(l, m, n, i)}&
\multicolumn{1}{r}{Real to Complex}					\\
{\tt <Type>3DCRDDFT(l, m, n, i)}&{\tt <Type>3DCRIDFT(l, m, n, i)}&
Complex to Real
\end{tabular}
\end{center}

\subsubsection{Return by Value (Out of Place)}
\begin{center}
\begin{tabular}{r|r|l}
\multicolumn{1}{c|}{Direct}&\multicolumn{1}{c|}{Inverse}&		\\
\hline
{\tt <Type>3DCDDFTC(l, m, n, i)}&{\tt <Type>3DCIDFTC(l, m, n, i)}&
Complex from Complex							\\
{\tt <Type>3DCDDFTR(l, m, n, i)}&{\tt <Type>3DCIDFTR(l, m, n, i)}&
Complex from Real							\\
{\tt <Type>3DRDDFTC(l, m, n, i)}&{\tt <Type>3DRIDFTC(l, m, n, i)}&
\multicolumn{1}{r}{Real from Complex}
\end{tabular}
\end{center}

\subsubsection{Resize}
{\tt resize(l, m, n, i)}

\end{document}

